<template>
  <div />
</template>

<script>
import * as d3 from "d3";

export default {
  name: "BubbleChart",

  data() {
    return {
      data: [
        {
          name: "10 años",
          title: "title",
          value: 10,
        },
        {
          name: "7 años",
          title: "title2",
          value: 7,
        },
        {
          name: "6 años",
          title: "title2",
          value: 6,
        },
        {
          name: "5 años",
          title: "title2",
          value: 5,
        },
        {
          name: "2 años",
          title: "title2",
          value: 2,
        },
      ],
      labels: [],
      width: 100,
      height: 100,

      colorScale: ["#4A148C", "#9652DF", "#B98CEA", "#7319D5", "#DCC5F4"],
    };
  },

  mounted() {
    this.render();
  },

  methods: {
    render() {
      const root = d3
        .pack()
        .size([this.width - 2, this.height - 2])
        .padding(3)(d3.hierarchy({ children: this.data }).sum((d) => d.value));

      const svg = d3
        .select(this.$el)
        .append("svg")
        .attr("viewBox", [0, 0, this.width, this.height])
        .attr("font-size", 10)
        .attr("font-family", "sans-serif")
        .attr("text-anchor", "middle");

      const node = svg
        .selectAll("g")
        .data(root.leaves())
        .join("g")
        .attr("transform", (d) => `translate(${d.x + 1},${d.y + 1})`);

      node
        .append("circle")
        .attr("id", (d, i) => (d.nodeUid = i))
        .attr("r", (d) => d.r)
        .attr("fill-opacity", 0.7)
        .attr("fill", (d, i) => this.colorScale[i]);

      node
        .append("text")
        .attr("clip-path", (d) => d.clipUid)
        .selectAll("tspan")
        .data((d) => d.data.name.split(/(?=[A-Z][a-z])|\s+/g))
        .join("tspan")
        .attr("x", 0)
        .attr("y", (d, i, nodes) => `${i - nodes.length / 2 + 0.8}em`)
        .text((d) => d);

      const format = d3.format(",d");

      node
        .append("title")
        .text(
          (d) =>
            `${d.data.title === undefined ? "" : `${d.data.title}`}${format(
              d.value
            )}`
        );
    },
  },
};
</script>
